function unwrapExports (x) {
	return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, 'default') ? x['default'] : x;
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var index_min = createCommonjsModule(function (module, exports) {

  function isUndef(e) {
    return "undefined" === e;
  }

  Object.defineProperty(exports, "__esModule", {
    value: !0
  });
  var isWeb = !isUndef(typeof window) && "onload" in window,
      isNode = !isUndef(typeof process) && !(!process.versions || !process.versions.node),
      isWeex = !isUndef(typeof callNative) || !isUndef(typeof WXEnvironment) && "Web" !== WXEnvironment.platform,
      isMiniApp = !isUndef(typeof my) && !isUndef(my.navigateTo),
      isWeChatMiniprogram = !isUndef(typeof wx) && !isUndef(wx.navigateTo);
  exports.isMiniApp = isMiniApp, exports.isNode = isNode, exports.isWeChatMiniprogram = isWeChatMiniprogram, exports.isWeb = isWeb, exports.isWeex = isWeex;
});
unwrapExports(index_min);
var index_min_1 = index_min.isMiniApp;
var index_min_2 = index_min.isNode;
var index_min_3 = index_min.isWeChatMiniprogram;
var index_min_4 = index_min.isWeb;
var index_min_5 = index_min.isWeex;

var lib = createCommonjsModule(function (module, exports) {

  Object.defineProperty(exports, '__esModule', {
    value: true
  });

  function isUndef(type) {
    return type === 'undefined';
  }

  var isWeb = !isUndef(typeof window) && 'onload' in window;
  var isNode = !isUndef(typeof process) && !!(process.versions && process.versions.node);
  var isWeex = !isUndef(typeof callNative) || !isUndef(typeof WXEnvironment) && WXEnvironment.platform !== 'Web';
  var isMiniApp = !isUndef(typeof my) && !isUndef(my.navigateTo);
  var isWeChatMiniprogram = !isUndef(typeof wx) && !isUndef(wx.navigateTo);
  exports.isMiniApp = isMiniApp;
  exports.isNode = isNode;
  exports.isWeChatMiniprogram = isWeChatMiniprogram;
  exports.isWeb = isWeb;
  exports.isWeex = isWeex;
});
unwrapExports(lib);
var lib_1 = lib.isMiniApp;
var lib_2 = lib.isNode;
var lib_3 = lib.isWeChatMiniprogram;
var lib_4 = lib.isWeb;
var lib_5 = lib.isWeex;

var universalEnv = createCommonjsModule(function (module) {
  {
    module.exports = lib;
  }
});

var lib$1 = createCommonjsModule(function (module, exports) {

  exports.__esModule = true;
  exports.isRpx = isRpx;
  exports.calcRpx = calcRpx;
  exports.getRpx = getRpx;
  exports.setRpx = setRpx;
  exports.getViewportWidth = getViewportWidth;
  exports.setViewportWidth = setViewportWidth;
  exports.setDecimalPixelTransformer = setDecimalPixelTransformer;
  exports.convertUnit = convertUnit;
  var RPX_REG = /[-+]?\d*\.?\d+rpx/g;
  var GLOBAL_RPX_COEFFICIENT = '__rpx_coefficient__';
  var GLOBAL_VIEWPORT_WIDTH = '__viewport_width__';
  var global = typeof window === 'object' ? window : typeof global === 'object' ? global : {}; // convertUnit method targetPlatform

  var targetPlatform = universalEnv.isWeb ? 'web' : universalEnv.isWeex ? 'weex' : ''; // Init toFixed method

  var unitPrecision = 4;

  var toFixed = function toFixed(number, precision) {
    var multiplier = Math.pow(10, precision + 1);
    var wholeNumber = Math.floor(number * multiplier);
    return Math.round(wholeNumber / 10) * 10 / multiplier;
  }; // Dedault decimal px transformer.


  var decimalPixelTransformer = function decimalPixelTransformer(rpx) {
    return parseFloat(rpx) * getRpx() + 'px';
  }; // Default decimal vw transformer.


  var decimalVWTransformer = function decimalVWTransformer(rpx) {
    return toFixed(parseFloat(rpx) / (getViewportWidth() / 100), unitPrecision) + 'vw';
  }; // Default 1 rpx to 1 px


  if (getRpx() === undefined) {
    setRpx(1);
  } // Viewport width, default to 750.


  if (getViewportWidth() === undefined) {
    setViewportWidth(750);
  }
  /**
   * Is string contains rpx
   * note: rpx is an alias to rpx
   * @param {String} str
   * @returns {Boolean}
   */


  function isRpx(str) {
    return typeof str === 'string' && RPX_REG.test(str);
  }
  /**
   * Calculate rpx
   * @param {String} str
   * @returns {String}
   */


  function calcRpx(str) {
    if (targetPlatform === 'web') {
      // In Web convert rpx to 'vw', same as driver-dom and driver-universal
      // '375rpx' => '50vw'
      return str.replace(RPX_REG, decimalVWTransformer);
    } else if (targetPlatform === 'weex') {
      // In Weex convert rpx to 'px'
      // '375rpx' => 375 * px
      return str.replace(RPX_REG, decimalPixelTransformer);
    } else {
      // Other platform return original value, like Mini-App and WX Mini-Program ...
      // '375rpx' => '375rpx'
      return str;
    }
  }

  function getRpx() {
    return global[GLOBAL_RPX_COEFFICIENT];
  }

  function setRpx(rpx) {
    global[GLOBAL_RPX_COEFFICIENT] = rpx;
  }

  function getViewportWidth() {
    return global[GLOBAL_VIEWPORT_WIDTH];
  }

  function setViewportWidth(viewport) {
    global[GLOBAL_VIEWPORT_WIDTH] = viewport;
  }
  /**
   * Set a function to transform unit of pixel,
   * default to passthrough.
   * @param {Function} transformer function
   */


  function setDecimalPixelTransformer(transformer) {
    decimalPixelTransformer = transformer;
  }

  var cache = Object.create(null);
  /**
   * Convert rpx.
   * @param value
   * @param prop
   * @param platform
   * @return {String} Transformed value.
   */

  function convertUnit(value, prop, platform) {
    var cacheKey = prop + "-" + value;
    var hit = cache[cacheKey];

    if (platform) {
      cacheKey += "-" + platform;
      targetPlatform = platform;
    }

    if (hit) {
      return hit;
    } else {
      value = value + '';
      return cache[cacheKey] = isRpx(value) ? calcRpx(value) : value;
    }
  }
});
unwrapExports(lib$1);
var lib_1$1 = lib$1.isRpx;
var lib_2$1 = lib$1.calcRpx;
var lib_3$1 = lib$1.getRpx;
var lib_4$1 = lib$1.setRpx;
var lib_5$1 = lib$1.getViewportWidth;
var lib_6 = lib$1.setViewportWidth;
var lib_7 = lib$1.setDecimalPixelTransformer;
var lib_8 = lib$1.convertUnit;

var STYLE = 'style';
var ID = 'id';
var TEXT = 'text';
var CHILDREN = 'children';
var EVENT_PREFIX_REGEXP = /^on[A-Z]/;
var ARIA_PREFIX_REGEXP = /^aria-/;
var HYPHEN_REGEXP = /\-(\w)/;
var EMPTY = '';

function updateWeexTextValue(node) {
  var value = node.children.map(function (child) {
    // Comment node type
    return child.nodeType === 8 ? child.value : EMPTY;
  }).join(EMPTY);
  node.setAttr('value', value);
}

var nodeMaps = {};
/* global __weex_document__ */

var document = typeof __weex_document__ === 'object' ? __weex_document__ : typeof document === 'object' ? document : null;
function getElementById(id) {
  return nodeMaps[id];
}
function createBody(type, props) {
  if (document.body) {
    return document.body;
  }

  var documentElement = document.documentElement;
  var body = document.createBody(type, props);
  documentElement.appendChild(body);
  return body;
}
function createComment(content) {
  return document.createComment(content);
}
function createEmpty() {
  return createComment(EMPTY);
}
function createText(text) {
  // Use comment node type mock text node
  return createComment(text);
}
function updateText(node, text) {
  node.value = text;
  updateWeexTextValue(node.parentNode);
}
function createElement(type, props) {
  if (props === void 0) {
    props = {};
  }

  var style = {};
  var originStyle = props.style;

  if (originStyle) {
    for (var prop in originStyle) {
      style[prop] = lib_8(originStyle[prop], prop);
    }
  }

  var node = document.createElement(type, {
    style: style
  });

  for (var _prop in props) {
    var value = props[_prop];

    if (_prop === CHILDREN) {
      continue;
    }

    if (value != null) {
      if (_prop === STYLE) {
        continue;
      } else if (EVENT_PREFIX_REGEXP.test(_prop)) {
        var eventName = _prop.slice(2).toLowerCase();

        addEventListener(node, eventName, value, props);
      } else {
        setAttribute(node, _prop, value);
      }
    }
  }

  return node;
}
function appendChild(node, parent) {
  parent.appendChild(node);

  if (parent.type === TEXT) {
    updateWeexTextValue(parent);
  }
}
function removeChild(node, parent) {
  parent = parent || node.parentNode;
  var id = node.attr && node.attr[ID];

  if (id != null) {
    nodeMaps[id] = null;
  }

  parent.removeChild(node);

  if (parent.type === TEXT) {
    updateWeexTextValue(parent);
  }
}
function replaceChild(newChild, oldChild, parent) {
  parent = parent || oldChild.parentNode;
  var previousSibling = oldChild.previousSibling;
  var nextSibling = oldChild.nextSibling;
  removeChild(oldChild, parent);

  if (previousSibling) {
    insertAfter(newChild, previousSibling, parent);
  } else if (nextSibling) {
    insertBefore(newChild, nextSibling, parent);
  } else {
    appendChild(newChild, parent);
  }
}
function insertAfter(node, after, parent) {
  parent = parent || after.parentNode;
  parent.insertAfter(node, after);

  if (parent.type === TEXT) {
    updateWeexTextValue(parent);
  }
}
function insertBefore(node, before, parent) {
  parent = parent || before.parentNode;
  parent.insertBefore(node, before);

  if (parent.type === TEXT) {
    updateWeexTextValue(parent);
  }
}
function addEventListener(node, eventName, eventHandler, props) {
  // https://github.com/apache/incubator-weex/blob/master/runtime/vdom/Element.js#L421
  var params = props[eventName + 'EventParams'];
  return node.addEvent(eventName, eventHandler, params);
}
function removeEventListener(node, eventName, eventHandler) {
  return node.removeEvent(eventName, eventHandler);
}
function removeAttribute(node, propKey, propValue) {
  if (propKey == ID) {
    nodeMaps[propValue] = null;
  } // Weex native will crash when pass null value


  return node.setAttr(propKey, undefined, false);
}
function setAttribute(node, propKey, propValue) {
  if (propKey == ID) {
    nodeMaps[propValue] = node;
  } // Weex only support `ariaLabel` format, convert `aria-label` format to camelcase


  if (ARIA_PREFIX_REGEXP.test(propKey)) {
    propKey = propKey.replace(HYPHEN_REGEXP, function (m, p) {
      return p.toUpperCase();
    });
  }

  return node.setAttr(propKey, propValue, false);
}
function setStyle(node, style) {
  for (var prop in style) {
    // Translate `rpx` to weex `px`
    style[prop] = lib_8(style[prop], prop);
  }

  node.setStyles(style);
}
function beforeRender() {
  // Turn off batched updates
  document.open(); // Set `rpx` unit converter

  lib_4$1(1);
}
function afterRender() {
  if (document.listener && document.listener.createFinish) {
    document.listener.createFinish();
  } // Turn on batched updates


  document.close();
}

export { addEventListener, afterRender, appendChild, beforeRender, createBody, createComment, createElement, createEmpty, createText, getElementById, insertAfter, insertBefore, removeAttribute, removeChild, removeEventListener, replaceChild, setAttribute, setStyle, updateText };
//# sourceMappingURL=driver-weex.mjs.map
